

from Tkinter import *
import tkSimpleDialog
import tkMessageBox
import Device
import RpcGrid


kDefaultServer = "http://localhost:8080/goform/RPC2"

class RpcMainFrame(Frame):
    def __init__(self, parent=None, **config):
        Frame.__init__(self, parent, config)
        self.pack()

        root = self.master
        self.menu = Menu(root)

        
        fileMenu = Menu(self.menu)
        root.config(menu=self.menu)

        self.menu.add_cascade(label="File", menu=fileMenu)
        fileMenu.add_command(label="Connect...", command=self.Connect)
        fileMenu.add_separator()
        fileMenu.add_command(label="Exit", command=self.Exit)

        self.rpcGrid = RpcGrid.RpcGrid(None, self)
        self.server = None
        

    def Connect(self):
        server = tkSimpleDialog.askstring("Server Address", "Enter Server URL (including port)")
        if server is not None:
            if 0 == len(server):
                server = kDefaultServer
            try:
                self.server = Device.Device(server, "system")
                self.rpcGrid.SetDevice(self.server)
                self.Poll()
            except Device.DeviceException, e:
                errorString = "\n".join(e.errorList)
                tkMessageBox.showwarning("Connect", "Unable to connect to %s\n%s"\
                                         % (server, errorString))
                                        

    def Poll(self):
        if self.server:
            self.server.Query("system")
            for row in self.rpcGrid:
                row.Update()
        self.after(1000, self.Poll)                
                

    def Exit(self):
        self.master.quit()


if __name__ == "__main__":
    app = RpcMainFrame()
    app.mainloop()
    
