from Tkinter import *
import Row

kRowCount = 16


class RpcGrid(Frame):
    def __init__(self, app=None, parent=None, **config):
        Frame.__init__(self, parent, config)
        self.app = app
        self.pack()
        self.rows = []
        self.Build()



    def Build(self):
        # build a header row first...
        header = Row.Row(None, self.app, self)
        header.pack()
        header.SetNumber("")
        header.SetLabel("Label")
        header.SetLowerAlarm("Lower Alarm")
        header.SetUpperAlarm("Upper Alarm")
        header.SetValue("Value")

        for i in range(kRowCount):
            newRow = Row.Row(i, self.app, self)
            newRow.pack()
            newRow.SetNumber(i+1)
            self.rows.append(newRow)

    def SetDevice(self, device):
        for row in self.rows:
            row.SetDevice(device)

            
    def __getitem__(self, index):
        if index < 0:
            index = kRowCount - index
        if index < 0 or index >= kRowCount:
            raise IndexError
        return self.rows[index]


if __name__ == "__main__":
    #RpcGrid().mainloop()
    root = Tk()
    f = Frame(root)
    f.pack()
    RpcGrid(None, f).mainloop()
    