

class ValueTree:
    def __init__(self, rootName, treeDict):
        self.tree = { rootName : treeDict }

    def GetValue(self, name, index=None):
        retval = None
        currentDict = self.tree

        parts = name.split(".")
        leaf = len(parts) - 1
        for i in range(leaf):
            currentDict = currentDict[parts[i]]
        retval = currentDict[parts[leaf]]
        if index is not None:
            retval = retval[index]
        return retval
    

                

    def SetValue(self, name, value, index=None):
        currentDict = self.tree
        parts = name.split(".")
        leaf = len(parts) - 1
        for i in range(leaf):
            currentDict = currentDict[parts[i]]

        if index is not None:
            currentDict[parts[leaf]][index] = value
        else:
            currentDict[parts[leaf]] = value
        

if __name__ == "__main__":
    tree = {'info': {'uptime': 319, 'name': 'DMF Tutorial', 'description': 'Imaginary Pseudo Device'}, 'values': {'upperAlarm': [100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100], 'lowerAlarm': [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], 'value': [-3, 66, 29, 92, 63, 56, 40, 104, 96, 84, 23, 104, 86, 66, 36, -2], 'label': ['Label 00', 'Label 01', 'Label 02', 'Label 03', 'Label 04', 'Label 05', 'Label 06', 'Label 07', 'Label 08', 'Label 09', 'Label 10', 'Label 11', 'Label 12', 'Label 13', 'Label 14', 'Label 15']}}
    t2 = {'uptime': 1000, 'name': 'substitute!', 'description': 'New Description!'}
    v = ValueTree("system", tree)
    
    
    #v.SetValue("system", tree)
    v.GetValue("zzz.qqq")
    v.GetValue("system.info.uptime")
    v.GetValue("system.values.value", 0)
    v.GetValue("system.values.value", 1)
    v.GetValue("system.values.value")
    v.SetValue("system.info", t2)
    v.GetValue("system.info.uptime")
    v.GetValue("system.info.name")
    v.GetValue("system.info.description")
    
    
    
