/*
 * Copyright (c) 2002, Infosys Technologies Ltd.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are 
 * met:
 *
 * 1) Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer. 
 * 2) Redistributions in binary form must reproduce the above
 * copyright notice, this list of conditions and the following
 * disclaimer in the documentation and/or other materials provided
 * with the distribution. 
 * 3) Neither the name of the Infosys Technologies Ltd. nor the names
 * of its contributors may be used to endorse or promote
 * products derived from this software without specific prior
 * written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT
 * HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
#pragma warning ( disable : 4786 )

#include "HttpSession.h"

std::string HttpSession::getAttribute(std::string name)
{
	if( _sessParamList.end() != _sessParamList.find(name) )
	{
		return  _sessParamList[name];
	}
	else
	{
		return "";
	}
}

std::vector<std::string> HttpSession::getAttributeNames()
{
	std::vector<std::string> attrNames;
	sessionMap::iterator mapIter = _sessParamList.begin();
	
	while (mapIter !=  _sessParamList.end() )
	{
		attrNames.push_back((*mapIter).first );
		mapIter++;
	}
	return 	attrNames;
}

void HttpSession::setAttribute(const char * name, const char * value)
{
	sessionMap::iterator mapIter = _sessParamList.begin();
	while (mapIter !=  _sessParamList.end() )
	{
		if( name == (*mapIter).first )
		{

			// It is so hard !!! to find any documentation 
			// for the std::iterator
			(*mapIter).second  = value;
			return;
		}
		mapIter++;
	}
	_sessParamList.insert(sessionMap::value_type(name, value) );
}

void HttpSession::removeAttribute(const char * name)
{
	_sessParamList.erase(name);
}

