/*
 * Copyright (c) 2002, Infosys Technologies Ltd.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are 
 * met:
 *
 * 1) Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer. 
 * 2) Redistributions in binary form must reproduce the above
 * copyright notice, this list of conditions and the following
 * disclaimer in the documentation and/or other materials provided
 * with the distribution. 
 * 3) Neither the name of the Infosys Technologies Ltd. nor the names
 * of its contributors may be used to endorse or promote
 * products derived from this software without specific prior
 * written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT
 * HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

#ifndef _MESSAGELOGGER_H_
#define _MESSAGELOGGER_H_

#include <fstream>
#include <string>
#include <stdarg.h>

//#include "ace\High_Res_Timer.h"

#include "cpp_servlet_dll.h"

class ACE_Time_Value;
class ACE_High_Res_Timer;

enum eLogLevel{
	eLogError = 1,
	eLogInfo,
	eLogDebug,
};

class CPP_SERVLET_DLL_API MessageLogger
{

public:
	MessageLogger();
	~MessageLogger();
	static void setLogFile (char* logFile);
	static void setLogLevel (eLogLevel logLevel);
	static void LogMessage (char messageType, char *location, char *message, ...);
	static void LogServletLog (const char *contextPath, const char *message);
	static void startTimer();
	static void stopTimer();
	static void getElapsedTime (ACE_Time_Value &tv);

private:
	static char* _logFile;
	static std::ofstream _logStream;
	static eLogLevel _logLevel;
	static ACE_High_Res_Timer timer;

};

#endif _MESSAGELOGGER_H_