/*
 * Copyright (c) 2002, Infosys Technologies Ltd.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are 
 * met:
 *
 * 1) Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer. 
 * 2) Redistributions in binary form must reproduce the above
 * copyright notice, this list of conditions and the following
 * disclaimer in the documentation and/or other materials provided
 * with the distribution. 
 * 3) Neither the name of the Infosys Technologies Ltd. nor the names
 * of its contributors may be used to endorse or promote
 * products derived from this software without specific prior
 * written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT
 * HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
#ifndef APPLICATION_CONTEXT_MANAGER_H
#define APPLICATION_CONTEXT_MANAGER_H

#include <string>
#include <map>

#include <dom\DOM.hpp>

#include "ServletContext.h"
#include "ServletConfigDictionary.h"

#include "../cpp_servlet_dll.h"
// namespace std

class CPP_SERVLET_DLL_API ApplicationContextManager
{

public:

	ApplicationContextManager (const char *contextFileName);
	
	ServletContext* getServletContext();
	ServletConfigDictionary* getServletConfigDictionary();
	// std::string getDeploymentDLLName();

	// strips the leading and trailing space ' ' chars from
	// the string str and returns
	static std::string StripSpaceChars(std::string &str);

private:

	void setContextFile(const char *contextFileName);

	ServletContext	*_servletContext;
	std::string		_contextPath;
	DOM_Element		_domElement;

};

#endif //APPLICATION_CONTEXT_MANAGER_H