/*
 * Copyright (c) 2002, Infosys Technologies Ltd.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are 
 * met:
 *
 * 1) Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer. 
 * 2) Redistributions in binary form must reproduce the above
 * copyright notice, this list of conditions and the following
 * disclaimer in the documentation and/or other materials provided
 * with the distribution. 
 * 3) Neither the name of the Infosys Technologies Ltd. nor the names
 * of its contributors may be used to endorse or promote
 * products derived from this software without specific prior
 * written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT
 * HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
#pragma warning ( disable : 4786 )

#include "ServletRequest.h"

std::string ServletRequest::getAttribute(std::string name)
{
	if( _paramList.end() != _paramList.find(name) )
	{
		return  _paramList[name];
	}
	else
	{
		return "";
	}
}

std::vector<std::string> ServletRequest::getAttributeNames()
{
	std::vector<std::string> attribNames;
	parameterMap::iterator mapIter = _paramList.begin();
	
	while (mapIter !=  _paramList.end() )
	{
		attribNames.push_back((*mapIter).first );
		mapIter++;
	}
	return 	attribNames;
}

void ServletRequest::setAttribute(std::string name, std::string  value)
{
	std::vector<std::string> attribNames;
	parameterMap::iterator mapIter = _paramList.begin();
	while (mapIter !=  _paramList.end() )
	{
		if( name == (*mapIter).first )
		{

			// It is so hard !!! to find any documentation 
			// for the std::iterator
			(*mapIter).second  = value;
			return;
		}
		mapIter++;
	}
	_paramList.insert(parameterMap::value_type(name, value) );
}

void ServletRequest::removeAttribute(std::string name)
{
	_paramList.erase(name);
}


std::vector<std::string> ServletRequest::getParameterValues(std::string name)
{
	std::vector<std::string> paramValues;
	parameterMap::iterator mapIter = _paramList.begin();
	while (mapIter !=  _paramList.end() )
	{
		if( name == (*mapIter).first )
		{

			// It is so hard !!! to find any documentation 
			// for the std::iterator
			paramValues.push_back((*mapIter).second );
		}
		mapIter++;
	}
	return 	paramValues;
}

void ServletRequest::setCharacterEncoding(std::string env) throw (ServletException)
{
	_characterEncoding = env;
}


std::string  ServletRequest::getLocale()
{
	if(_localeList.size() > 0)
		return _localeList[0];
	else
	{
		// ADD CODE TO RETURN THE DEFAULT SERVER LOCALE;
		return "";
	}
}

std::vector<std::string> ServletRequest::getLocales()
{
	return _localeList;
	// ADD CODE TO RETURN THE DEFAULT SERVER LOCALE;
}

// As of now just constructing a dummy one and returning.
// Code should be modified after carefully understanding all 
// the aspects of a request dispatcher.
RequestDispatcher getRequestDispatcher(std::string path)
{
	RequestDispatcher rD(path.c_str());
	return rD;
}