/*
 * Copyright (c) 2002, Infosys Technologies Ltd.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are 
 * met:
 *
 * 1) Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer. 
 * 2) Redistributions in binary form must reproduce the above
 * copyright notice, this list of conditions and the following
 * disclaimer in the documentation and/or other materials provided
 * with the distribution. 
 * 3) Neither the name of the Infosys Technologies Ltd. nor the names
 * of its contributors may be used to endorse or promote
 * products derived from this software without specific prior
 * written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT
 * HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */


#ifndef APACHE_HTTP_SERVLET_RESPONSE_H
#define APACHE_HTTP_SERVLET_RESPONSE_H


// Created this class just to implement the sendHeaders 
// method declared and not defined in the base class

// ************** NOTE  __ IMPORTANT *****************
// If _DLL is defined and run time library is "debug multi-threaded
// dll then HttpServletResponse.h (basically headers including template classes)
// should be included before the apache's stuff e.g. httpd.h
// ************** NOTE  __ IMPORTANT *****************

#include "HttpServletResponse.h"

extern "C"
{
#include "httpd.h"
}



class ApacheHttpServletResponse : public HttpServletResponse
{

public:

	ApacheHttpServletResponse(request_rec *r)
	{ _r = r; }

	void sendHeaders() throw(ServletException);

	void sendError(int sc, std::string msg) throw( ServletException );

	void sendError(int sc) throw( ServletException);

	void sendRedirect(std::string location) throw (ServletException);

	void setStatus(int sc);

private:
	request_rec *_r;

	void sendErrorHeaders();
};

#endif