/*
 * Copyright (c) 2002, Infosys Technologies Ltd.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are 
 * met:
 *
 * 1) Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer. 
 * 2) Redistributions in binary form must reproduce the above
 * copyright notice, this list of conditions and the following
 * disclaimer in the documentation and/or other materials provided
 * with the distribution. 
 * 3) Neither the name of the Infosys Technologies Ltd. nor the names
 * of its contributors may be used to endorse or promote
 * products derived from this software without specific prior
 * written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT
 * HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */


#pragma warning ( disable : 4786 )

#include "ApacheServletOutputStream.h"
#include "http_protocol.h"

#define MAX_SERVLET_OUTPUT_DATA_READ 500

void ApacheServletOutputStream::flush()
{
	// Algorithm: Read _charCounter characters from the stream
	// reset the char counts etc. 
	// write to client using ap_rwrite
	// flush using ap_rflush

	// check whether sgetn() increments the pointer or not. 
	// if not we need to move the pointer ourselves.
	char outStr[MAX_SERVLET_OUTPUT_DATA_READ]; // have a big enough buffer
	int numRead =0, numRemaining = _charCounter;

	
	while (numRemaining > 0)
	{
		if(MAX_SERVLET_OUTPUT_DATA_READ > numRemaining)
		{
			numRead = sgetn(outStr, numRemaining);
			numRemaining = 0;
		}
		else
		{
			numRead = sgetn(outStr, MAX_SERVLET_OUTPUT_DATA_READ);
			numRemaining -= MAX_SERVLET_OUTPUT_DATA_READ;
		}
		// Move the pointer (input) 
		//pubseekoff(numRead, std::ios_base::cur, std::ios_base::in);
		ap_rwrite(outStr, numRead, _r);
	}
	

	
	//std::string tryStr;
	// strcpy(tryStr, "<br> <B> Hello from TryServletExample  </B> \n");
	//tryStr = "<br> <B> Hello again from TryServletExample </B> /n";
	// tryStr += str();
	
	
	//char strChar[250];
	//strcpy(strChar, tryStr.c_str() );
	//ap_rwrite(strChar, strlen(strChar) , _r);
	
	ap_rflush(_r);
	_charCounter = 0;

}
