/*
 * Copyright (c) 2002, Infosys Technologies Ltd.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are 
 * met:
 *
 * 1) Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer. 
 * 2) Redistributions in binary form must reproduce the above
 * copyright notice, this list of conditions and the following
 * disclaimer in the documentation and/or other materials provided
 * with the distribution. 
 * 3) Neither the name of the Infosys Technologies Ltd. nor the names
 * of its contributors may be used to endorse or promote
 * products derived from this software without specific prior
 * written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT
 * HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */



#ifndef DEPLOYMENT_CONFIG_MANAGER_H_
#define DEPLOYMENT_CONFIG_MANAGER_H_

#include <map>
#include <string>

#include "base_servlet\ServletContext.h"
#include "base_servlet\ServletConfigDictionary.h"


typedef std::map<std::string, ServletContext*> servletContextMap;
typedef std::map<std::string, ServletConfigDictionary*> servletConfigDictionaryMap;
// typedef std::map<std::string, std::string>userServletDLLMap;

class DeploymentConfigManager
{

public:
	void initialize(const char *rootPath);

	ServletContext* getServletContext (std::string appName);
	ServletConfig* getServletConfig(std::string appName, std::string servletName);
	// std::string getDeploymentDLLName(std::string appName);
	std::vector<std::string> getAllDeploymentDLLNames();

private:
	servletContextMap				_srvContextMap;
	servletConfigDictionaryMap		_srvConfigDictMap;
	// userServletDLLMap				_srvDLLMap;

};


#endif // DEPLOYMENT_CONFIG_MANAGER_H_