/*
 * Copyright (c) 2002, Infosys Technologies Ltd.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are 
 * met:
 *
 * 1) Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer. 
 * 2) Redistributions in binary form must reproduce the above
 * copyright notice, this list of conditions and the following
 * disclaimer in the documentation and/or other materials provided
 * with the distribution. 
 * 3) Neither the name of the Infosys Technologies Ltd. nor the names
 * of its contributors may be used to endorse or promote
 * products derived from this software without specific prior
 * written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT
 * HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

#pragma warning ( disable : 4786 )

#include "HelloWorldServlet.h"
#include "ServletFactory.h"

// This macro registers the servlet to the servlet factory
// Give the name of the servlet same as the servlet class name

// Commenting this out temparorily to make work with static lib
// Should retain this as the DLL model works.
// Uncommenting it back as now the dll model is working !!

REGISTER_SERVLET( HelloWorldServlet, "HelloWorldServlet")


void HelloWorldServlet::doGet(HttpServletRequest & req, HttpServletResponse & resp)
	throw( ServletException)
{
	

	std::string title = "Servlet Output";

	std::string userName = req.getParameter("username");

	resp.setContentType("text/html");
	
	ServletOutputStream & srvltOpStream = resp.getOutputStream();

	srvltOpStream.print("<HTML><HEAD><TITLE>");
	srvltOpStream.print(title);
	srvltOpStream.print("</TITLE></HEAD><BODY>");
	srvltOpStream.print("<H1>" + title + "</H1>");
	srvltOpStream.print("<P>Hello World from ");


	if (userName != "")
	{
		srvltOpStream.print("<B>" + userName + "</B>");
	}
	srvltOpStream.print("!!!");
	srvltOpStream.print("</P></BODY></HTML>");

	
	// This line is very important (atleast for now) as it won't write 
	// anything to client otherwise.
	resp.flushBuffer();
	
}

void HelloWorldServlet::doPost(HttpServletRequest & req, HttpServletResponse & resp)
	throw (ServletException)
{
	doGet(req, resp);
}
