/*
 * Copyright (c) 2002, Infosys Technologies Ltd.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are 
 * met:
 *
 * 1) Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer. 
 * 2) Redistributions in binary form must reproduce the above
 * copyright notice, this list of conditions and the following
 * disclaimer in the documentation and/or other materials provided
 * with the distribution. 
 * 3) Neither the name of the Infosys Technologies Ltd. nor the names
 * of its contributors may be used to endorse or promote
 * products derived from this software without specific prior
 * written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT
 * HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

#include "soapH.h"	// include generated proxy and SOAP support

int main(int argc, char **argv)
{ struct soap soap;	// allocate gSOAP runtime environment
  char *sym;
  char *host;
  char *port;
  float q;

  char queryStr[200];
  strcpy(queryStr, "http://");
  if(argc >=4 )
  {
	  host = argv[1];
	  port = argv[2];
	  sym  = argv[3];
  }
  else 
  {
	  host = "localhost";
	  port = "80";
	  if (argc > 1)
	  {
		sym = argv[1];
	  }
	  else
	  {
		//sym  = "XYZ";
		printf("Usage : \n");
		printf("1) %s <hostname> <portno> <symbol>\n", argv[0]);
		printf("2) %s <symbol>\n   {Defaults used host=localhost; port=80} \n", argv[0]);
		// printf("3) %s\n   {Defaults used host=localhost; port=80; symbol=XYZ} \n", argv[0]);
		exit(0);
	  }
	  
  }
  printf("Connecting to Host : %s ; port : %s\n", host, port);

  strcat(queryStr, host);
  strcat(queryStr, ":");
  strcat(queryStr, port);
  strcat(queryStr, "/cpp_servlet/soap/SOAPServlet?soap_res=quote");
  printf("URL = %s\n", queryStr);

  soap_init(&soap);	// must initialize
  // if (soap_call_ns__getQuote(&soap, "http://services.xmethods.net/soap", NULL, sym, &q) == 0)
  // if (soap_call_ns__getQuote(&soap, "http://localhost:80/cpp_servlet/soap/SOAPServlet?soap_res=quote", NULL, sym, &q) == 0)
  if (soap_call_ns__getQuote(&soap, queryStr, NULL, sym, &q) == 0)
    printf("\nCompany - %s    Quote - %f\n", sym, q);
  else
  { soap_print_fault(&soap, stderr);
    soap_print_fault_location(&soap, stderr);
  }
  return 0;
}

// The namespace mapping table is required and associates namespace prefixes with namespace names:
struct Namespace namespaces[] =
{//{"ns-prefix", "ns-name" [, "ns-name-input-pattern"]}
   {"SOAP-ENV", "http://schemas.xmlsoap.org/soap/envelope/"}, // MUST be first
   {"SOAP-ENC", "http://schemas.xmlsoap.org/soap/encoding/"}, // MUST be second
   {"xsi", "http://www.w3.org/1999/XMLSchema-instance", "http://www.w3.org/*/XMLSchema-instance"}, // MUST be third
   {"xsd", "http://www.w3.org/1999/XMLSchema", "http://www.w3.org/*/XMLSchema"},
   {"ns", "urn:xmethods-delayed-quotes"},	// Method namespace URI
   {NULL, NULL}
};


