/*
 * Copyright (c) 2002, Infosys Technologies Ltd.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are 
 * met:
 *
 * 1) Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer. 
 * 2) Redistributions in binary form must reproduce the above
 * copyright notice, this list of conditions and the following
 * disclaimer in the documentation and/or other materials provided
 * with the distribution. 
 * 3) Neither the name of the Infosys Technologies Ltd. nor the names
 * of its contributors may be used to endorse or promote
 * products derived from this software without specific prior
 * written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT
 * HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

#pragma warning ( disable : 4786 )

#include "tryErrorServlet.h"
#include "ServletFactory.h"


// This macro registers the servlet to the servlet factory
// Give the name of the servlet same as the servlet class name

// Commenting this out temparorily to make work with static lib
// Should retain this as the DLL model works.
// Uncommenting it back as now the dll model is working !!
REGISTER_SERVLET( TryErrorServlet, "TryErrorServlet")


void TryErrorServlet::doGet(HttpServletRequest & req, HttpServletResponse & resp)
	throw( ServletException)
{
	
	ServletOutputStream & srvltOpStream = resp.getOutputStream();
	// Just says hello from its name and 
	// writes all the parameters back
	// std::vector<std::string> attrList = req.getAttributeNames();

	// resp.setContentType("text/html");

	// resp.sendRedirect("http://localhost/try_form.html");
	
	std::string errcode = req.getParameter("error");
	if(errcode == "")
	{
		// usage is error=<err code> (as query param )
		resp.sendError(404);
	}
	else
	{
		resp.sendError(atoi(errcode.c_str() ));
	}
	
}

void TryErrorServlet::doPost(HttpServletRequest & req, HttpServletResponse & resp)
	throw (ServletException)
{
	doGet(req, resp);
}
