#include "ipp.h"

bool xcorr(Ipp32f *x, int nx,   // x[n]
		   Ipp32f *y, int ny,   // y[n]
		   Ipp32f **r, int *nr, // rxy
		   int *startLag)      // 1st lag we compute 
{
	// this function assumes that x & y are of power-of-2 lengths!

	// the lags we care about
	int lagLo = -(nx-1),
		lagHi = ny-1;

	// # of elements in the output array
	*nr = lagHi-lagLo+1;

	// allocate output array (use Intel SP function for mem allocation)
	*r = ippsMalloc_32f(*nr);

	IppStatus st = ippsCrossCorr_32f(x, nx, 
		                             y, ny,
				                     *r, *nr, 
								     lagLo);

	*startLag = lagLo;
	return (st==ippStsNoErr);
}