int matched_filter(Ipp32f *x, int nx, // x[n]
				   Ipp32f *y, int ny) // y[n]
{
	// matched filter, return value is the lag where
	// the maximum cross-correlation by sequences
	// x and y occurs.

	// both of the following to be initialized
	// by the function xcorr()
	Ipp32f *crossCorrelation = 0;
	int nxcorr = 0,
		startLag = 0;

	// perform the cross-correlation of x[n] & y[n]
	xcorr(x, nx, y, ny, &crossCorrelation, &nxcorr, &startLag);

	// | crossCorrelation |
	ippsAbs_32f_I(crossCorrelation, nxcorr);

	// max value of | crossCorrelation |
	int maxLag = 0;
	Ipp32f maxCrossCorr = 0.0;
	ippsMaxIndx_32f(crossCorrelation, nxcorr, &maxCrossCorr, &maxLag);

	return (maxLag+startLag);
}