function [l, rxy] = cross_corr(x, y)
%
% CROSS_CORR   compute the cross-correlation of two sequences
%    [lags, rxy] = CROSS_CORR(x,y) returns the cross-correlation
%    of x[n] and y[n] in rxy.  The output l contains the
%    lag indices.
%

% time-reverse x[n]
x = fliplr(x);

% construct lag indices
l = 1-length(x):length(y)-1;

% use built-in Matlab function conv to perform cross-correlation
rxy = conv(y, x);

