% construct cross-correlation kernel
w = 11; % width of part of the triangular pulse, should be odd
tri = zeros(1, w);
halfway = ceil(w/2);
tri(halfway) = 1;
slope = 1/(halfway-1);
tri(1:halfway-1) = [0:halfway-2].*slope;
tri(halfway+1:w) = fliplr(tri(1:halfway-1));
tri = [-tri tri(2:w) -tri(2:w)];
n_tri = length(tri);

% input waveform
x = 0:63; nx = length(x);
y = zeros(1, nx);
start = 25;
y(start : start+length(tri)-1) = tri;

% noisy input test data
beta = [0.1 0.2 0.3]; n_beta = length(beta);
N = 10; % # test signals, per beta value

% construct test data
yn = zeros(N, nx, n_beta);
for ii=1:n_beta % for each beta value
    B = beta(ii);
    for n=1:N % for each test signal
        yn(n, :, ii) =  y + randn(1, nx) .* B;
    end
end

% compute SNRs
snr_avg = zeros(1, n_beta);
for ii=1:n_beta
    for n=1:N
        signal2noise_ratio = 20*log10(norm(y)/norm(y-yn(n, :, ii)));
        snr_avg(ii) = snr_avg(ii) + signal2noise_ratio;
    end
    snr_avg(ii) = snr_avg(ii) / N;
end

disp(sprintf('Beta\t\tAvg Snr'))
for ii=1:n_beta
    disp(sprintf('%f\t%f', beta(ii), snr_avg(ii)));
end